/// <summary>
/// WebService for FNDE_CHANGEV2.Workflow_26_4_2010_13_321.Workflow generated with NVelocity
/// </summary>
namespace Default
{
    using System;
    using System.IO;
    using LogicBase.Core;
    using LogicBase.Core.Data;
    using LogicBase.Core.Utilities;
    using LogicBase.Core.ExecutionEngine;
    using LogicBase.Core.Models.Workflow;
    using System.Web.Services;
    
    [WebService(Namespace="www.transparentlogic.com")]
    public class MyService : System.Web.Services.WebService 
    {        
		[WebMethod()]
        [LogicBase.Framework.LogTraceExtensionAttribute()]
        public virtual string Execute () 
        {
			WorkflowExecutionEngine __lb__engine = WorkflowExecutionEngine.GetEngine();
			
			LogicBase.Core.Data.OrchestrationData __lb__data = new LogicBase.Core.Data.OrchestrationData(false, true);
						
			return __lb__engine.Start(__lb__data, "Primary");
        }        
		
		        
		        
        // Nov 18 - HSO - Update to allow you to generate a web service that has an additional method.
                
        public struct TrackingIDAndProcessID
        {
			public string WorkflowTrackingID;
			public string ProcessID;
			
			public TrackingIDAndProcessID(string workflowTrackingID, string reportProcessID)
			{
				WorkflowTrackingID = workflowTrackingID;
				ProcessID = reportProcessID;
			}
        }
        
        [WebMethod()]
        [LogicBase.Framework.LogTraceExtensionAttribute()]
        public TrackingIDAndProcessID ExecuteAndReturnPID()
        {
			WorkflowExecutionEngine __lb__engine = WorkflowExecutionEngine.GetEngine();
			
			LogicBase.Core.Data.OrchestrationData __lb__data = new LogicBase.Core.Data.OrchestrationData(false, true);
						
			
			// HSO -- Have to pass in global data to get processreportid out accurately.
			TrackingIDProcessIDResultHolder mainResult = __lb__engine.StartAndReturnAllIDs(__lb__data, "Primary");
			
			// Since we know that the first thing that happens is that the report process id 
			// gets set by the reporting component, we can just fetch this out of Global Data
			// now before returning.
			return new TrackingIDAndProcessID(
				mainResult.WorkflowTrackingID, 
				mainResult.ReportProcessID);
        }
        
                
        [WebMethod()]
        [LogicBase.Framework.LogTraceExtensionAttribute()]
        public virtual bool CheckTimeoutsAndEscalations() 
        {
            WorkflowExecutionEngine.GetEngine();
            return WorkflowExecutionEngine.GetEngine().ProcessTimeoutsAndEscalations();
        }
        
        [WebMethod()]
        [LogicBase.Framework.LogTraceExtensionAttribute()]
        public virtual LogicBase.Core.Models.Workflow.WorkStatus TrackStatus(string workflowTrackingId) 
        { 
            WorkflowExecutionEngine.GetEngine();
            return WorkStatusServiceFactory.GetService().Retrieve(workflowTrackingId);
        }
        
        [WebMethod()]
        [LogicBase.Framework.LogTraceExtensionAttribute()]
        public virtual LogicBase.Core.Models.Workflow.WorkflowTaskResult[] GetCurrentWorkflowTasks(string workflowTrackingId) 
        {
            WorkflowExecutionEngine.GetEngine();
            return WorkQueueFactory.GetQueue().GetCurrentWorkflowTasks(CurrentProjectHolder.GetInstance().Project.ProjectSetupData.ServiceId, workflowTrackingId);
        }
        
        [WebMethod()]
        [LogicBase.Framework.LogTraceExtensionAttribute()]
        public virtual string[] GetCurrentWorkflowTaskIDs (string workflowTrackingId) 
        {
            WorkflowExecutionEngine.GetEngine();
            return WorkQueueFactory.GetQueue().GetCurrentWorkflowTaskIDs(CurrentProjectHolder.GetInstance().Project.ProjectSetupData.ServiceId, workflowTrackingId);
        }
        
                
        [WebMethod()]
        [LogicBase.Framework.LogTraceExtensionAttribute()]
        public virtual bool CheckAutoStart ()
        {
            WorkflowExecutionEngine __lb__engine = WorkflowExecutionEngine.GetEngine();

			ISingleEntryPointComponentModel compModel =
				(ISingleEntryPointComponentModel)CurrentProject.GetPrimaryComponentModel();

			if (compModel.InitialComponent is IAutoStartWorkflowComponent)
			{
				IAutoStartWorkflowComponent autoStartComp = (IAutoStartWorkflowComponent)compModel.InitialComponent;
				IData data = new OrchestrationData(false, true);
	            
				return autoStartComp.StartWorkflow(data);
			} else {
				throw new Exception("initial component is not an IAutoStartWorkflowComponent");
			}
        }
        
        public WorkflowProject CurrentProject
		{
			get
			{
				if (CurrentProjectHolder.GetInstance().Project == null)
				{
					CurrentProjectHolder.GetInstance().Project =
						WorkflowProject.OpenProject(new FileInfo(Path.Combine(AppDomain.CurrentDomain.BaseDirectory, "FNDE_CHANGEV2.Workflow_26_4_2010_13_321.Workflow")));
				}

				return (WorkflowProject)CurrentProjectHolder.GetInstance().Project;
			}
		}
        
        		
				
			
	}
	
	
}
